function C=chem_strato2(ciclo, CP, CR)

warning off all


N=12; % numero de ecuaciones
M=10;% numero de especies quimicas





% ciclo es un string que puede ser :
% 1 chapman
% 2 HOX2
% 3 HOX4
% 4 NOX1
% 5 CLOX1
% 6 todos



%--------------------------------------------------------------------------


global c n

h=[10:2.5:50]*1000; 
T=[linspace(217,217,4) linspace(217,225,5) linspace(225,270,8)];
n=length(h);
R=287;
g=9.8;

jO2= 10^(-14)*[ 0.001 0.001 0.005 1.701 12.75 66.54 262.1 852.7 2189 5380 10650 18262 27420 40165 47820 60000 66900 ];
jO3= 10^(-4)*[ 4.594 5.235 5.641 5.665 5.688 5.712 5.783 5.856 6.000 6.270 6.469 7.191 8.297 9.574 10.98 11.54 12.67 ];


k(1,:)=jO2;
k(2,:)=6*10^(-34)*((300./T).^2.3);
k(3,:)=jO3;
k(4,:)=8*10^(-12)*exp(-2060./T);
k(5,:)=1.6e-12*exp(-940./T);
k(6,:)=3e-11*exp(200./T);
k(7,:)=k(5,:);
k(8,:)=1.1e-14*exp(-500./T);
k(9,:)=2e-12*exp(-1400./T);
k(10,:)=6.5e-12*exp(120./T);
k(11,:)=2.9e-11*exp(-260./T);
k(12,:)=3e-11*exp(70./T);


Tm(n)=(T(n-1)+T(n))/2;
for i=1:n-1
Tm(i)=(T(i)+T(i+1))/2;
end


P(1)=25000;
for i=1:n-1
P(i+1)= P(i)*exp(-(h(i+1)-h(i))*g/(R*Tm(i)));
end

total_density=1e16*[870.0 580.9 410.1 277.7 192.4 131.5 91.56 61.99 42.76...
29.50 20.35 13.84 9.680 6.554 4.521 3.090 2.121];

MM=0.78*total_density;

O2=0.2*total_density;

% A=6.022*10^23; 
% R2=8.3143;
% MM=(A*P)./(R2*T);

%--------------------------------------------------------------------------


%M
ci(:,1)=MM';

%O
aux=exp(linspace(log(1e7),log(7e11),length(h)));
ci(:,2)=aux';

%O2
%aux=0.2.*ones(1,length(h)).*MM*2;
ci(:,3)=O2';

% O3
aux=exp(linspace(log(10^12),log(8*10^12),5));
aux=aux(1:end-1);
aux2=exp(linspace(log(8*10^12),log(8*10^11),13));
ci(:,4)=[aux aux2]';


%OH
aux=exp(linspace(log(1e6),log(2e7),length(h)));
ci(:,5)=aux';

%HO2
aux=exp(linspace(log(1e9),log(3e7) ,3 )); %15 30
aux=aux(1:end-1);
aux2=exp(linspace(log(3e7),log(4e7),7));
aux2=aux2(1:end-1);
aux3=exp(linspace(log(4e7),log(1e6),9));
ci(:,6)=[aux aux2 aux3]';

%NO
aux=exp(linspace(log(1e8),log(4e8),3));  %15 37.5
aux=aux(1:end-1);
aux2=exp( linspace(log(4e8) ,log(2e9),10));
aux2=aux2(1:end-1);
aux3=exp(linspace(log(2e9),log(4e8),6));
ci(:,7)=[aux aux2 aux3]';

%NO2
aux=exp(linspace(log(6e7),log(4e8),3));  %15 32.5
aux=aux(1:end-1);
aux2=exp( linspace(log(4e8) ,log(2e9),8));
aux2=aux2(1:end-1);
aux3=exp(linspace(log(2e9),log(7e6),8));
ci(:,8)=[aux aux2 aux3]';

%Cl
aux=exp(linspace(log(1e3),log(2e6),length(h)));
ci(:,9)=aux';

%ClO
aux=exp(linspace(log(2.5e7),log(8e6),2));
aux=aux(1:end-1);
aux2=exp(linspace(log(8e6),log(8e7),4));  %%20
aux2=aux2(1:end-1);
aux3=exp(linspace(log(8e7),log(1.5e8),8));  %%37.5
aux3=aux3(1:end-1);
aux4=exp(linspace(log(1.5e8),log(6e6) ,6));  %%37.5
ci(:,10)=[ aux aux2 aux3 aux4  ]';

%--------------------------------------------------------------------------


%Reacciones

% MM=1
% O=2
% O2=3
% O3=4
% 
% 0H=5
% HO2=6
% 
% NO=7
% NO2=8
% 
% CL=9
% CLO=10


name{1}='MM';
name{2}='O';
name{3}='O2';
name{4}='O3';

name{5}='0H';
name{6}='HO2';

name{7}='NO';
name{8}='NO2';

name{9}='CL';
name{10}='CLO';

%--------------------------------------------------------------------------


N=12; % numero de ecuaciones
M=10;% numero de especies quimicas

CR=zeros(N,M);

CR(1,3)=1;
CR(2,[1 2 3])=1;
CR(3,4)=1;
CR(4,[2 4])=1;
CR(5,[4 5])=1;
CR(6,[2 6])=1;
CR(7,[4 5])=1;
CR(8,[4 6])=1;
CR(9,[4 7])=1;
CR(10,[2 8])=1;
CR(11,[4 9])=1;
CR(12,[2 10])=1;

for i=1:N
    for j=1:M
        if CR(i,j)>0
            IR(i,j)=true;
        else
            IR(i,j)=false;
        end
    end
end

CP=zeros(N,M);

CP(1,2)=2;
CP(2,[1  4])=1;
CP(3,[2 3])=1;
CP(4,3)=2;
CP(5,[3 6])=1;
CP(6,[3 5])=1;
CP(7,[3 6])=1;
CP(8,[3 5])=[2 1];
CP(9,[3 8])=1;
CP(10,[3 7])=1;
CP(11,[3 10])=1;
CP(12,[3 9])=1;

for i=1:N
    for j=1:M
        if CP(i,j)>0
            IP(i,j)=true;
        else
            IP(i,j)=false;
        end
    end
end

hor=1e8;

%--------------------------------------------------------------------------
%--------------------------------------------------------------------------
%--------------------------------------------------------------------------


switch ciclo
    
    case 1

    Iec=[1:4]; % indice de ecuaciones
    Ies=[1:4]; % indice de las especies
    
    for c=1:n
        
         cond_ini=zeros(1,10);
         for j=1:length(Ies)
         cond_ini(Ies(j))=ci(c,Ies(j));
         end
         
         % y es de largo 10, pero solo evolucionaran length(Ies) especies !!!!!
     
         [t sol]= ode23s(@(t,y) lado_derecho(y,t,IR, CR, IP, CP, k, N, M, Iec,Ies, n),[0 hor],cond_ini);

%          sol=sol(:,Ies);
         for j=1: M % length(Ies)
        
         C(c,j)=sol(end,j);
    
         end

    end
% 
%     for j=1:length(Ies)
% 
% 
%     figure(j);
%     plot(C(:,j),h');
%     title(name{j});
% 
%     end

%--------------------------------------------------------------------------

    case 2

    Iec=[1:6];
    Ies=[1 2 3 4 5 6];
    
  
    
    for c=1:n
        
         cond_ini=zeros(1,10);
         for j=1:length(Ies)
         cond_ini(Ies(j))=ci(c,Ies(j));
         end
         
         % y es de largo 10, pero solo evolucionaran length(Ies) especies !!!!!
     
         [t sol]= ode23s(@(t,y) lado_derecho(y,t,IR, CR, IP, CP, k, N, M, Iec,Ies, n),[0 hor],cond_ini);

%          sol=sol(:,Ies);
         for j=1: M % length(Ies)
        
         C(c,j)=sol(end,j);
    
         end

    end
% 
%     for j=1:length(Ies)
% 
% 
%     figure(j);
%     plot(C(:,j),h');
%     title(name{j});
% 
%     end

%--------------------------------------------------------------------------
    
    
    case 3

    Iec=[1 2 3 4 7 8];
    Ies=[1 2 3 4 5 6];
    
    for c=1:n
        
         cond_ini=zeros(1,10);
         for j=1:length(Ies)
         cond_ini(Ies(j))=ci(c,Ies(j));
         end
         
         % y es de largo 10, pero solo evolucionaran length(Ies) especies !!!!!
     
         [t sol]= ode23s(@(t,y) lado_derecho(y,t,IR, CR, IP, CP, k, N, M, Iec,Ies, n),[0 hor],cond_ini);

%          sol=sol(:,Ies);
         for j=1: M % length(Ies)
        
         C(c,j)=sol(end,j);
    
         end

    end

%     for j=1:length(Ies)
% 
% 
%     figure(j);
%     plot(C(:,j),h');
%     title(name{j});
% 
%     end

%--------------------------------------------------------------------------
   
    
    case 4
 
    
    Iec=[1 2 3 4 9 10];
    Ies=[1 2 3 4 7 8];
    
    for c=1:n
        
         cond_ini=zeros(1,10);
         for j=1:length(Ies)
         cond_ini(Ies(j))=ci(c,Ies(j));
         end
         
         % y es de largo 10, pero solo evolucionaran length(Ies) especies !!!!!
     
         [t sol]= ode23s(@(t,y) lado_derecho(y,t,IR, CR, IP, CP, k, N, M, Iec,Ies, n),[0 hor],cond_ini);

%          sol=sol(:,Ies);
         for j=1: M % length(Ies)
        
         C(c,j)=sol(end,j);
    
         end

    end

   

%     for j=1:length(Ies)
% 
% 
%     figure(j);
%     plot(C(:,j),h');
%     title(name{j});
% 
%     end

%--------------------------------------------------------------------------
    
    case 5
    
    
    Iec=[1 2 3 4 11 12];
    Ies=[1 2 3 4 9 10];
    
    for c=1:n
        
         cond_ini=zeros(1,10);
         for j=1:length(Ies)
         cond_ini(Ies(j))=ci(c,Ies(j));
         end
         
         % y es de largo 10, pero solo evolucionaran length(Ies) especies !!!!!
     
         [t sol]= ode23s(@(t,y) lado_derecho(y,t,IR, CR, IP, CP, k, N, M, Iec,Ies, n),[0 hor],cond_ini);

%          sol=sol(:,Ies);
         for j=1: M % length(Ies)
        
         C(c,j)=sol(end,j);
    
         end

    end

   
    

%     for j=1:length(Ies)
% 
% 
%     figure(j);
%     plot(C(:,j),h');
%     title(name{j});
% 
%     end
    
%--------------------------------------------------------------------------

    case 6

    Iec=[1:12];
    Ies=[1:10];
    
    for c=1:n
        
         cond_ini=zeros(1,10);
         for j=1:length(Ies)
         cond_ini(Ies(j))=ci(c,Ies(j));
         end
         
         % y es de largo 10, pero solo evolucionaran length(Ies) especies !!!!!
     
         [t sol]= ode23s(@(t,y) lado_derecho(y,t,IR, CR, IP, CP, k, N, M, Iec,Ies, n),[0 hor],cond_ini);

%          sol=sol(:,Ies);
         for j=1: M % length(Ies)
        
         C(c,j)=sol(end,j);
    
         end

    end

   

%     for j=1:length(Ies)

%     figure(j);
%     plot(C(:,j),h');
%     title(name{j});
% 
%     end

end

%--------------------------------------------------------------------------
%--------------------------------------------------------------------------
%--------------------------------------------------------------------------
%--------------------------------------------------------------------------


end %function