%principal

warning off all
clc
clear all
close all

%Altura

h=[10:2.5:50]*1000; 
n=length(h);

%Definicion de las matrices de reactantes y productos.

%CR(i,j) corresponde al coeficiente de la especie j en la ecuacion i, en el
%lado izquierdo de la escuacion.

%CP(i,j) corresponde al coeficiente de la especie j en la ecuacion i, en el
%lado derecho de la escuacion.

%La idea de este codigo es intentar calcular toda la evolucion de la
%quimica a partir de solo las estas dos matrices, las cuales contienen la
%estructura de la quimica.

%Observacion: La ventaja de esto es que por un lado es facil introducir nuevos ciclos al
%sistema mediente una adaptacion de estas metrices. Además permite
%visualizar relaciones generales a partir de su estructura: bloques
%independientes, bloques simetricos, etc..... Como desventaja toma mucho tiempo de computo,
%sin embargo puede ser llevado a fortran........... eventualmente quisas sea
%posible estudiar mas a fondo como la estructura de esta matrices dan
%informacion acerca del problema----> en el sentido de matrices de
%adyacencia en un grafo con pesos/tasa de reaccion asociadas a sus arcos ....???



N=12; % numero de ecuaciones
M=10;% numero de especies quimicas

CR=zeros(N,M);

CR(1,3)=1;
CR(2,[1 2 3])=1;
CR(3,4)=1;
CR(4,[2 4])=1;
CR(5,[4 5])=1;
CR(6,[2 6])=1;
CR(7,[4 5])=1;
CR(8,[4 6])=1;
CR(9,[4 7])=1;
CR(10,[2 8])=1;
CR(11,[4 9])=1;
CR(12,[2 10])=1;


CP=zeros(N,M);

CP(1,2)=2;
CP(2,[1  4])=1;
CP(3,[2 3])=1;
CP(4,3)=2;
CP(5,[3 6])=1;
CP(6,[3 5])=1;
CP(7,[3 6])=1;
CP(8,[3 5])=[2 1];
CP(9,[3 8])=1;
CP(10,[3 7])=1;
CP(11,[3 10])=1;
CP(12,[3 9])=1;


C1=chem_strato2(1, CP, CR);
C2=chem_strato2(2, CP, CR);
C3=chem_strato2(3, CP, CR);
C4=chem_strato2(4, CP, CR); 
C5=chem_strato2(5, CP, CR);
C6=chem_strato2(6, CP, CR);


plot(C1(:,4),h,'-ok')
hold on
plot(C2(:,4),h,'-sr')
plot(C3(:,4),h,'--xb')
plot(C4(:,4),h,'--pg')
plot(C5(:,4),h,'--<c')
plot(C6(:,4),h,'--hm')
title('Ozono')
ylabel('Altura(km)')
xlabel('moleculas por cm cubico')
legend({'Chapman','HOx2','HOx4','NOx','ClOx','Todos'})
















